<?php  
/* created by Pinoccio
   (based on http://forums.codecharge.com/posts.php?post_id=77123)
   v.1.0

   - codearea css not defined! (class name: code_container, element type: textarea)
   - blockquote css not defined! (class name: quote, element type: div)
   
   I disabled for my page some tags... find comment: DISABLED (don't forget to edit the text of allowed markup in language files)
*/
  
function bbcode_format ($str, $doHtmlent) {  
    if($doHtmlent == true)
      $str = htmlentities($str);  
  
    $simple_search = array(  
                //added line break  
                //DISABLED'/\[br\]/is',  
                '/\[b\](.*?)\[\/b\]/is',  
                '/\[i\](.*?)\[\/i\]/is',  
                '/\[u\](.*?)\[\/u\]/is',  
                '/\[urlx\=(.*?)\](.*?)\[\/urlx\]/is', //special type for links within the page, do not make public  
                '/\[url\=(.*?)\](.*?)\[\/url\]/is',  
                '/\[url\](.*?)\[\/url\]/is',  
                '/\[align\=(left|center|right)\](.*?)\[\/align\]/is',  
                '/\[img\](.*?)\[\/img\]/is',  
                '/\[mail\=(.*?)\](.*?)\[\/mail\]/is',  
                '/\[mail\](.*?)\[\/mail\]/is',  
                '/\[font\=(.*?)\](.*?)\[\/font\]/is',  
                '/\[size\=(.*?)\](.*?)\[\/size\]/is',  
                '/\[color\=(.*?)\](.*?)\[\/color\]/is',  
                //added textarea for code presentation  
                //DISABLED'/\[codearea\](.*?)\[\/codearea\]/is',  
                //added pre class for code presentation  
                //DISABLED'/\[code\](.*?)\[\/code\]/is',  
                //added paragraph  
                '/\[p\](.*?)\[\/p\]/is',  
                );  
  
    $simple_replace = array(  
		            //added line break  
                //DISABLED'<br />',  
                '<b>$1</b>',  
                '<i>$1</i>',  
                '<u>$1</u>',  
                '<a href="$1">$2</a>', //special type for links within the page, do not make public  
		            // added nofollow to prevent spam  
                '<a href="$1" rel="nofollow" title="$2 - $1" target="_blank">$2</a>',  
                '<a href="$1" rel="nofollow" title="$1" target="_blank">$1</a>',  
                '<div style="text-align: $1;">$2</div>',  
		            //added alt attribute for validation  
                '<img src="$1" alt="" />',  
                '<a href="mailto:$1">$2</a>',  
                '<a href="mailto:$1">$1</a>',  
                '<span style="font-family: $1;">$2</span>',  
                '<span style="font-size: $1;">$2</span>',  
                '<span style="color: $1;">$2</span>',  
		            //added textarea for code presentation  
		            //DISABLED'<textarea class="code_container" rows="30" cols="70">$1</textarea>',  
		            //added pre class for code presentation  
		            //DISABLED'<pre class="code">$1</pre>',  
		            //added paragraph  
		            '<p>$1</p>',  
                );  
  
    // Do simple BBCode's  
    $str = preg_replace ($simple_search, $simple_replace, $str);  
  
    // Do <blockquote> BBCode  
    $str = bbcode_quote ($str);  
  
    return $str;  
}  
  
function bbcode_quote ($str) {  
    //added div and class for quotes  
    $open = '<blockquote><div class="quote">';  
    $close = '</div></blockquote>';  
  
    // How often is the open tag?  
    preg_match_all ('/\[quote\]/i', $str, $matches);  
    $opentags = count($matches['0']);  
  
    // How often is the close tag?  
    preg_match_all ('/\[\/quote\]/i', $str, $matches);  
    $closetags = count($matches['0']);  
  
    // Check how many tags have been unclosed  
    // And add the unclosing tag at the end of the message  
    $unclosed = $opentags - $closetags;  
    for ($i = 0; $i < $unclosed; $i++) {  
        $str .= '</div></blockquote>';  
    }  
  
    // Do replacement  
    $str = str_replace ('[' . 'quote]', $open, $str);  
    $str = str_replace ('[/' . 'quote]', $close, $str);  
  
    return $str;  
}  

?>